## userv-utils 0.3

=== Makefile ===
# Copyright (C) 2000,2003 Ian Jackson
#
# This is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with userv-utils; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# $Id: Makefile,v 1.13 2003/07/06 20:47:12 ian Exp $

VERSION=0.2.99.0.1

all:
	@echo >&2 'See README.  This is not a unified package.'

SUBDIRS_DISTCLEAN=	www-cgi ipif

distclean:
	find . \( -name '*~' -o -name '#*#' -o -name '*.o' -o -name core \
		-o -name dist_tmp -o -name userv-utils-\*.tar.gz \
		-o -name '.#*' \) \
		-print0 | xargs -0r rm -rf --
	for f in $(SUBDIRS_DISTCLEAN); do make -C $$f distclean; done

dist_tmp=dist_tmp/userv-utils-$(VERSION)
dist_prune=\( -name CVS -o -name 'dist_tmp*' \)
dist:			distclean
	rm -rf dist_tmp*
	mkdir dist_tmp $(dist_tmp)
	find . $(dist_prune) -prune -o -type d -print | \
		sed -e 's#.*#mkdir -p $(dist_tmp)/&#' | sh
	find . $(dist_prune) -prune -o -type f -print | \
		sed -e 's#.*#ln & $(dist_tmp)/&#' | sh
	cd dist_tmp && tar cf ../$(dist_tmp).tar `basename $(dist_tmp)`
	gzip -9 $(dist_tmp).tar
	mv $(dist_tmp).tar.gz .

=== dyndns/Makefile ===
# Makefile
# installation runes for userv-dyndns

# Copyright (C) 2003 Ian Jackson
#
# This is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with userv-utils; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# $Id: Makefile,v 1.1 2003/07/06 20:32:27 ian Exp $

include ../settings.make

install:
		mkdir -p $(shareuserv)/dyndns $(varlibuserv)/dyndns/tmp
		cp service update $(shareuserv)/dyndns
		cp install-script $(shareuserv)/dyndns/install

install-examples:
		mkdir -p $(services)
		cp dyndns $(services)/dyndns.distrib
		cp dyndns-domains $(etcuserv)/dyndns-domains.example
		echo usdyndns >$(etcuserv)/dyndns-service-users.example

install-docs:
		mkdir -p $(docdir)/userv-dyndns
		cp INSTALL $(docdir)/userv-dyndns

=== groupmanage/Makefile ===
# Makefile
# installation runes for groupmanage

# Copyright (C) 2003 Ian Jackson
# This file is part of groupmanage, part of userv-utils
#
# This is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with userv-utils; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# $Id: Makefile,v 1.2 2003/07/06 21:25:01 ian Exp $

include ../settings.make

install:
		mkdir -p $(bindir)
		cp groupmanage $(bindir)/.

install-examples:
		mkdir -p $(etcdir) $(services)
		cp groupmanage.conf $(etcdir)/groupmanage.conf.example
		cp services $(services)/groupmanage.distrib

install-docs:
		mkdir -p $(docdir)/groupmanage
		cp INSTALL groupmanage.text $(docdir)/groupmanage/.

=== ipif/Makefile ===
# Makefile for ipif/udptunnel stuff

# Copyright (C) 1999-2000,2003 Ian Jackson
# This file is part of ipif, part of userv-utils
#
# This is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with userv-utils; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# $Id: Makefile,v 1.18 2003/07/06 21:25:01 ian Exp $

include ../settings.make

varlibvpn=	$(varlibuserv)/vpn
etcvpn=		$(etcdir)/userv/vpn

PROGRAM_TARGETS=	udptunnel-forwarder udptunnel-reconf
TARGETS=		service blowfishtest $(PROGRAM_TARGETS)
PROGRAMS=		udptunnel $(PROGRAM_TARGETS)

MECHFILES=	null pkcs5 timestamp sequence blowfish
MECHOBJS=	$(foreach m, $(MECHFILES), mech-$m.o)

OBJS_FORWARD=	forwarder.o $(MECHOBJS) blowfish.o automech.c utils.c
OBJS_BFTEST=	blowfishtest.o blowfish.o hex.o

all:		$(TARGETS)

install:	all
		mkdir -p $(bindir) $(libuserv) $(services) \
			$(varlibvpn) $(shareuserv)
		cp -b service $(libuserv)/ipif
		cp -b $(PROGRAMS) $(bindir)/.
		cp ipif $(services)/ipif:new
		set -e; cd $(services); test -f ipif || mv ipif:new ipif
		cp udptunnel-vpn-config.m4 udptunnel-vpn-defaults \
			$(shareuserv)/.

install-docs:

install-examples:
		mkdir -p $(etcvpn)
		cp *.example $(etcvpn)/.

udptunnel-reconf:	udptunnel-reconf.pl Makefile
		perl -pe '	\
	print "\
\$$shareuserv= \"$(shareuserv)\";\n\
\$$etcvpn= \"$(etcvpn)\";\n\
\$$varlibvpn= \"$(varlibvpn)\";\n" if m#^\# \@\@\@\-#;	\
	$$_="" if m/^\# \@\@\@\-/ .. m/^\# \-\@\@\@/;	\
		'	\
			<$< >$@.new
		chmod +x $@.new
		mv -f $@.new $@


udptunnel-forwarder:	$(OBJS_FORWARD)
		$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $(OBJS_FORWARD)

blowfishtest:		$(OBJS_BFTEST)
		$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $(OBJS_BFTEST)

automech.h:		automechgen.sh Makefile
		./$< $(MECHFILES)

automech.c:		automech.h

clean:
		rm -f *.o core automech.[ch] *~ ./#*#

realclean distclean:	clean
		rm -f $(TARGETS)

forwarder.o $(MECHOBJS) automech.o utils.o:	forwarder.h automech.h
blowfish.o mech-blowfish.o blowfishtest.o:	blowfish.h
blowfishtest.o hex.o:				hex.h

=== misc/Makefile ===
# Makefile
# installation runes for userv-dyndns

# Copyright (C) 2003 Ian Jackson
#
# This is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with userv-utils; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# $Id: Makefile,v 1.1 2003/07/06 20:32:27 ian Exp $

include ../settings.make

install:
		mkdir -p $(bindir)
		cp mailq-wrapper $(bindir)/mailq

install-examples:
		mkdir -p $(services)
		cp mailq ndc-reload $(services)/.

install-docs:

=== www-cgi/Makefile ===
# Copyright (C) 1999,2003 Ian Jackson
#
# This is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with userv-utils; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# $Id: Makefile,v 1.6 2003/07/06 20:47:12 ian Exp $


include ../settings.make

uslibdir=	$(libdir)/userv/cgi
uslibcgidir=	$(uslibdir)/cgi

TARGETS=	ucgi ucgitarget

all:		$(TARGETS)

OBJS=		ucgi.o ucgitarget.o ucgicommon.o

ucgi:		ucgi.o ucgicommon.o
ucgitarget:	ucgitarget.o ucgicommon.o

$(OBJS):	ucgi.h

install:	all
		mkdir -p $(uslibcgidir)
		cp -b ucgitarget $(uslibdir)/target
		cp -b ucgi $(uslibcgidir)/
		ln -sf ucgi $(uslibcgidir)/ucgi-debug

install-examples:

install-docs:

clean distclean realclean:
		rm -f $(TARGETS)

=== debian/changelog ===
userv-utils (0.3) unstable; urgency=medium

  dyndns:
  * New dyndns service.

  ucgi:
  * add HTTP_REFERER.
  * Fix path in www-cgi userv service default configuration.

  ipif/udptunnel:
  * Use slip, not cslip (!)
  * service MAXEXROUTES increased from 5 to 50.
  * Set default max clock skew to 45/45, not 10/30.
  * Allow config file to override default clock skew and lag.
  * Report nonzero death of m4 better.
  * Add a few missing #include's of <string.h>.
  * Minor fixes to INSTALL.

  groupmanage:
  * new name-regexp feature.
  * admin-group is understood in config file but currently ignored.
  * file locations configurable.
  * groupmanage: do not claim that root doesn't exist.
  * groupmanage: configurable group name length limit.
  (Thanks to reports and patches from Ben Harris at Cambridge University.)

  Packaging changes:
  * Debianisation.
  * New Makefiles in various directories; still not wonderful.
  * Removed some common stuff from */Makefile to settings.make.
  * Copyright notices updated.
  * Moved changelog to debian/changelog.

 -- Ian Jackson <ian@davenant.greenend.org.uk>  Tue,  6 Jun 2006 22:02:17 +0100

userv-utils (0.2.3) unstable; urgency=low

  * udptunnel-reconf can write a known_hosts file for you.

 -- Ian Jackson <ian@davenant.greenend.org.uk>  Mon, 11 Feb 2002 21:46:48 +0000

userv-utils (0.2.2) unstable; urgency=low

  * udptunnel-reconf default script pauses for 10s between restarts.
  * udptunnel-reconf inittab entries default to having </dev/null.
  * udptunnel-reconf understands forbid_remote set to `-'.
  * forbid_remote is a per-tunnel option.
  * udptunnel-vpn-config.m4 allows global file to override as intended.
  * www-cgi passes HTTP_COOKIE header.
  * indirect ssh via V_sshinvoke.
  * userv-ipif config file allows exclusions in network permissions.

 -- Ian Jackson <ian@davenant.greenend.org.uk>  Sat, 15 Dec 2001 17:55:06 +0000

userv-utils (0.2.1) unstable; urgency=low

  * New udptunnel-reconf program for generating invoke scripts, inittab
    entries, and the like, for a multi-host VPN.

  * service.c (userv ipif) /32 prefixes work properly now.
  * `make distclean' works in ipif, www-cgi and top level.

 -- Ian Jackson <ian@davenant.greenend.org.uk>  Mon, 11 Dec 2000 02:45:58 +0000

userv-utils (0.2.0) unstable; urgency=low

  Improvements to ipif (tunnelling/VPN facility):
  * INSTALL instructions much improved and README created.
  * Patch to slattach included.
  * Documentation comments improved.

 -- Ian Jackson <ian@davenant.greenend.org.uk>  Mon, 18 Sep 2000 01:31:01 +0100

userv-utils (0.1.90) unstable; urgency=low

  * ipif/INSTALL instructions, such as they are, included.

  * ipif service now supports `=' character in addrs in ipif-networks, for
    local endpoint only.

 -- Ian Jackson <ian@davenant.greenend.org.uk>  Wed, 21 Jun 2000 23:48:10 +0100

userv-utils (0.1.9) unstable; urgency=low

  * Completely revamped udptunnel (in ipif) - now does encryption.

 -- Ian Jackson <ian@davenant.greenend.org.uk>  Sun, 18 Jun 2000 14:41:36 +0100

userv-utils (0.1) experimental; urgency=low

  * Initial release.

 -- Ian Jackson <ian@davenant.greenend.org.uk>  Tue,  9 Nov 1999 23:24:58 +0000

# Local variables:
# mode: debian-changelog
# End:

=== debian/control ===
Source: userv-utils
Section: admin
Priority: extra
Maintainer: Ian Jackson <ian@chiark.greenend.org.uk>
Standards-Version: 2.1.1.0

Package: userv-ipif
Architecture: any
Depends: userv
Recommends: ssh
Description: VPN system (and user-mode network interface)
 userv-ipif is a userv service to allow non-root users to create
 network interfaces implemented in user space.  No kernel patches are
 required (the kernel's built-in SLIP driver is used).
 .
 Based on this, udptunnel is a a simple but flexible VPN program which
 uses ssh for authentication and key exchange but sends the packets
 over UDP.  (Other VPN-over-ssh programs typically do PPP-over-TCP,
 which yields poor perfoormance.)  Note that udptunnel is not IPSEC.
 .
 The default configuration does set up any users with permission to
 create network interfaces such as VPN endpoints.

Package: userv-dyndns
Architecture: all
Depends: userv, chiark-utils-bin
Recommends: bind
Description: dynamic DNS for shell account users
 userv-dyndns is a userv service which allows non-root users to
 modify individual DNS records in specified zones in a controlled way.
 .
 Typically, this can be used to provide a `dyndns.org'-like service
 which is modifiable by shell account users.
 .
 The default configuration does not set up any users with permission
 to modify the DNS.

Package: userv-cgi
Architecture: any
Depends: userv
Recommends: httpd
Description: user-provided CGI scripts invoked by userv
 This package contains ucgi, a userv service which allows CGI programs
 to be provided which do not run as the webserver user, but instead
 are owned by a particular other account.
 .
 Similar effects can be achieved with Apache's suexec; this package is
 for administrators who do not trust suexec and wish to defend the
 webserver from the CGI script providers, and vice versa, as much as
 possible.  This is achieved by using userv to do the cross-account
 call, rather than a custom setuid helper.
 .
 The default configuration allows the webserver user to invoke users'
 CGI programs from each user's ~/public-GI, but to allow external
 callers to do this, the webserver will also need to be configured.

Package: userv-groupmanage
Architecture: all
Depends: userv
Description: user-controlled group membership
 groupmanage is a userv service which allows individual shell users to
 create UN*X groups, and/or to change the membership of existing
 groups of which they are recorded as the manager.
 .
 The default configuration allows users to create and manage a few
 groups, but is reasonably conservative.

Package: userv-misc
Architecture: all
Depends: userv
Description: miscellaneous small userv scripts
 This package a few small userv services.  Since you must choose
 whether to install this package or not as one lump, the default
 configuration for each script does not give users any new abilities.
 .
 mailq - allow users to view the mail queue
 ndc-reload  - allow certain users to reload the nameserver

=== debian/rules ===
#!/usr/bin/make -f

subdirs_build=	ipif www-cgi
subdirs_nobuild=dyndns groupmanage misc
package=	userv-utils
packages_indep=	userv-dyndns userv-groupmanage userv-misc
packages_arch=	userv-ipif userv-cgi
packages=	$(packages_indep) $(packages_arch)

cwd=	$(shell pwd)
d=	$(cwd)/debian
t=	$d/tmp

build:
	$(checkdir)
	set -e; for s in $(subdirs_build); do $(MAKE) -C $$s all; done
	touch build

clean:
	$(checkdir)
	rm -f build
	set -e; for s in $(subdirs_build); do \
		$(MAKE) -C $$s -i distclean || \
		$(MAKE) -C $$s -f Makefile.in distclean; \
	done
	rm -rf *~ debian/tmp debian/*~ debian/files* debian/substvars*

binary-prep:
	$(checkdir)
	rm -rf debian/tmp*
	#
	#
	set -e; for s in $(subdirs_build) $(subdirs_nobuild); do \
		$(MAKE) -C $$s install install-docs install-examples \
			prefix=$t/userv-$$s/usr \
			etcdir=$t/userv-$$s/etc \
			varlib=$t/userv-$$s/var/lib; \
	done
	#
	mv debian/tmp/userv-www-cgi debian/tmp/userv-cgi
	mv debian/tmp/userv-groupmanage/usr/share/doc/groupmanage \
	   debian/tmp/userv-groupmanage/usr/share/doc/userv-groupmanage
	#
	set -e; for p in $(packages); do \
		install -d $t/$$p/DEBIAN $t/$$p/usr/share/doc/$$p; \
		cp debian/copyright debian/changelog \
			$t/$$p/usr/share/doc/$$p/; \
		ln -s changelog.gz \
			$t/$$p/usr/share/doc/$$p/changelog.Debian.gz; \
		gzip -9v $t/$$p/usr/share/doc/$$p/changelog; \
		done
	#
	rename 's/\.example$$//' $t/userv-ipif/etc/userv/vpn/*.example \
		$t/userv-dyndns/etc/userv/dyndns-service-users.example \
		$t/userv-groupmanage/etc/groupmanage.conf.example
	rename 's/\.distrib$$//' $t/*/etc/userv/services.d/*.distrib
	rename 's/$$/\.disabled/' $t/userv-misc/etc/userv/services.d/mailq
	set -e; for p in $(packages); do \
		cd $t/$$p; \
		test ! -d etc || \
		  find etc -type f -exec printf '/%s\n' '{}' ';' \
			>>DEBIAN/conffiles; \
	done
	#
	mv $t/userv-misc/usr/bin/mailq $t/userv-misc/usr/bin/mailq.userv
	#
#	gzip -9f $t/*/usr/share/man/man*/*

binary-hook-userv-misc:
binary-hook-userv-groupmanage:
binary-hook-userv-cgi:
binary-hook-userv-dyndns:
binary-hook-userv-ipif:

binary-one:
	set -e; for f in preinst postinst prerm postrm conffiles; do \
		test -f debian/$p/$$f || continue; \
		cp debian/$p/$$f $t/$p/DEBIAN/$$f; \
		chmod u=rwX,go=rX $t/$p/DEBIAN/$$f; \
	done
	dpkg-gencontrol -p$p -P$t/$p -Tdebian/sv-$p
	chown -R root.root debian/tmp
	chmod -R g-ws debian/tmp
	debian/rules binary-hook-$p
	dpkg --build $t/$p ..

binary-indep:	checkroot build binary-prep
	set -e; for p in $(packages_indep); do \
		debian/rules binary-one p=$$p; done

binary-arch:	checkroot build binary-prep
	$(checkdir)
	dpkg-shlibdeps -Tdebian/sv-userv-ipif \
		$t/userv-ipif/usr/bin/udptunnel-forwarder \
		$t/userv-ipif/usr/lib/userv/ipif
	dpkg-shlibdeps -Tdebian/sv-userv-cgi \
		$t/userv-cgi/usr/lib/userv/cgi/target \
		$t/userv-cgi/usr/lib/userv/cgi/cgi/ucgi
	set -e; for p in $(packages_arch); \
		do debian/rules binary-one p=$$p; done

define checkdir
	test -f ipif/service.c
endef

# Below here is fairly generic really

binary:		binary-indep binary-arch

source diff:
	@echo >&2 'source and diff are obsolete - use dpkg-source -b'; false

checkroot:
	$(checkdir)
	test root = "`whoami`"

.PHONY: binary binary-arch binary-indep clean checkroot

## userv-utils 0.6.1-2

=== git-daemon/Makefile ===
# Makefile for userv-git-daemon
#
# This was written by Tony Finch <dot@dotat.at> and subsequently
# heavily modified by Ian Jackson <ijackson@chiark.greenend.org.uk>
# You may do anything with it, at your own risk.
# http://creativecommons.org/publicdomain/zero/1.0/

include ../settings.make

gituser=	userv-git
varloggit=	$(varlog)/git

TARGETS=	git-upload-pack inetd.conf git-daemon git-service logrotate

SUBSTVARS=	libuserv etcuserv varloggit gituser

CONFIGS=	$(services)/git-upload-pack \
		$(etcuserv)/git-urlmap \
		$(etcdir)/logrotate.d/userv-git-daemon

all:		$(TARGETS)

sedscript:	Makefile read-urlmap
		echo >$@.new '$(foreach f, $(SUBSTVARS), s,@$f@,$($f),g; )'
		echo >>$@.new '/@@READ_URLMAP@@/c\'
		@#'
		perl >>$@.new -pe 's/\\/\\\\/g; s/$$/\\/' <read-urlmap
		mv -f $@.new $@

%:		%.in sedscript
		set -e; \
		sed -f sedscript <$< >$@.new; \
		if test -x $<; then chmod +x $@.new; fi; \
		mv -f $@.new $@

install:	all
		mkdir -p $(libuserv) $(etcuserv) $(services) \
			$(etcdir)/logrotate.d
		install -d -o $(gituser) -g adm $(varloggit)
		cp git-daemon git-service $(libuserv)
		cp git-upload-pack $(services)/git-upload-pack:new
		cp git-urlmap $(etcuserv)/git-urlmap:new
		cp logrotate $(etcdir)/logrotate.d/userv-git-daemon:new
		set -e; for f in $(CONFIGS); do \
			if test -f $$f; then continue; fi; \
			mv $$f:new $$f; \
		done

mkdocdir:
		mkdir -p $(docdir)/userv-git-daemon

install-docs:	mkdocdir
		cp README $(docdir)/userv-git-daemon/README

install-examples: all mkdocdir
		cp inetd.conf $(docdir)/userv-git-daemon/inetd.conf

distclean clean:
		rm -f $(TARGETS) *~

# end

=== ucgi/Makefile ===
# Copyright 1996-2013,2016 Ian Jackson <ijackson@chiark.greenend.org.uk>
# Copyright 1998 David Damerell <damerell@chiark.greenend.org.uk>
# Copyright 1999,2003
#    Chancellor Masters and Scholars of the University of Cambridge
# Copyright 2010 Tony Finch <fanf@dotat.at>
# Copyright 2013,2016 Mark Wooding <mdw@distorted.org.uk>
#
# This is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with userv-utils; if not, see http://www.gnu.org/licenses/.


include ../settings.make

uslibdir=	$(libdir)/userv/ucgi
uslibcgidir=	$(uslibdir)/cgi
usdocdir=	$(docdir)/userv-ucgi

TARGETS=	ucgi ucgitarget

all:		$(TARGETS)

OBJS=		ucgi.o ucgitarget.o ucgicommon.o

ucgi:		ucgi.o ucgicommon.o
ucgitarget:	ucgitarget.o ucgicommon.o

$(OBJS):	ucgi.h

install:	all
		mkdir -p $(uslibcgidir)
		cp -b ucgitarget $(uslibdir)/target
		cp -b ucgi $(uslibcgidir)/
		ln -sf ucgi $(uslibcgidir)/ucgi-debug

install-examples:

install-docs:
		mkdir -p $(usdocdir)/examples
		cp INSTALL README.custom-env-filter $(usdocdir)/.
		cp srm.conf.fragment $(usdocdir)/examples/.
		sed -e 's#/usr/local#$(prefix)#' user-cgi.text \
			>$(usdocdir)/userv-cgi.text

clean distclean realclean:
		rm -f $(TARGETS) *.o

=== debian/changelog ===
userv-utils (0.6.1-2) unstable; urgency=medium

  * Source-only upload for testing migration.
  * Add Lintian override for malformed-debian-changelog-version.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sat, 06 Nov 2021 13:13:32 -0700

userv-utils (0.6.1-1) unstable; urgency=medium

  * Initial release (Closes: #991906).

 -- Sean Whitton <spwhitton@spwhitton.name>  Wed, 04 Aug 2021 15:32:01 -0700


# Local variables:
# mode: debian-changelog
# End:

=== debian/rules ===
#!/usr/bin/make -f

# Copyright 1996-2013,2016 Ian Jackson <ijackson@chiark.greenend.org.uk>
# Copyright 1998 David Damerell <damerell@chiark.greenend.org.uk>
# Copyright 1999,2003
#    Chancellor Masters and Scholars of the University of Cambridge
# Copyright 2010 Tony Finch <fanf@dotat.at>
#
# This is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with userv-utils; if not, see http://www.gnu.org/licenses/.

subdirs_build=	ipif ucgi git-daemon
subdirs_nobuild=dyndns groupmanage misc
package=	userv-utils
packages_indep=	userv-dyndns userv-groupmanage userv-utils userv-git-daemon
packages_arch=	userv-ipif userv-cgi
packages=	$(packages_indep) $(packages_arch)

SHELL=/bin/bash

cwd=	$(shell pwd)
d=	$(cwd)/debian

%:
	dh $@

override_dh_auto_configure:

override_dh_auto_build:
	$(checkdir)
	set -e; for s in $(subdirs_build); do \
		$(MAKE) -C $$s all; \
	done
	touch build

override_dh_auto_install:
	$(checkdir)
	-
	set -e; for p in $(packages); do rm -rf $d/$$p; done
	-
	set -e; for s in $(subdirs_build) $(subdirs_nobuild); do \
		t=$d/userv-$$s; \
		rm -rf $$t; \
		$(MAKE) -C $$s install install-docs install-examples \
			prefix=$$t/usr \
			etcdir=$$t/etc \
			vardir=$$t/var \
			gituser=root \
		; \
	done
	-
	mv debian/userv-misc debian/userv-utils
	-
	mv $d/userv-ipif/usr/share/doc/userv-ipif/{service.c.txt,ipif.txt}
	-
	set -e; cd debian/userv-ucgi/usr/share/doc/userv-ucgi;	\
		rename 's/^/ucgi-/' *
	-
	set -e; cd debian/userv-groupmanage/usr/share/doc;	\
		mv groupmanage userv-groupmanage;		\
		rm userv-groupmanage/INSTALL
	-
	set -e; for p in userv-ipif userv-ucgi userv-groupmanage; do	\
		(cd debian/$$p/usr/share/doc;			\
		 mv $$p userv-utils);				\
		cp -al debian/$$p/. debian/userv-utils/.;	\
	done
	-
	perl -pe 's{/usr/local/}{/usr/}' ucgi/www-cgi	\
		>debian/userv-utils/etc/userv/services.d/www-cgi
	-
	rename 's/\.example$$//' $d/userv-ipif/etc/userv/vpn/*.example \
		$d/userv-dyndns/etc/userv/dyndns-service-users.example \
		$d/userv-utils/etc/groupmanage.conf.example
	rename 's/\.distrib$$//' $d/*/etc/userv/services.d/*.distrib
	-
	mv $d/userv-utils/usr/bin/mailq $d/userv-utils/usr/bin/mailq.userv
	-
	set -e; cd $d/userv-utils/etc/userv;			\
		mkdir services-available;			\
		mv services.d/* services-available/

override_dh_install:

override_dh_auto_clean:
	$(checkdir)
	rm -f build
	set -e; for s in $(subdirs_build); do \
		$(MAKE) -C $$s -i distclean || \
		$(MAKE) -C $$s -f Makefile.in distclean; \
	done
	rm -rf *~ debian/tmp debian/*~ debian/files* debian/substvars*

define checkdir
	test -f ipif/service.c
endef

# Below here is fairly generic really

checkroot:
	$(checkdir)
	test root = "`whoami`"

## userv-utils 0.6.1-3

=== Makefile ===
# Copyright 1996-2013 Ian Jackson <ijackson@chiark.greenend.org.uk>
# Copyright 1998 David Damerell <damerell@chiark.greenend.org.uk>
# Copyright 1999,2003
#    Chancellor Masters and Scholars of the University of Cambridge
# Copyright 2010 Tony Finch <fanf@dotat.at>
#
# This is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with userv-utils; if not, see http://www.gnu.org/licenses/.

all:
	@echo >&2 'See README.  This is not a unified package.'

SUBDIRS_DISTCLEAN=	www-cgi ipif git-daemon

distclean:
	find . \( -name '*~' -o -name '#*#' -o -name '*.o' -o -name core \
		-o -name dist_tmp -o -name userv-utils-\*.tar.gz \
		-o -name '.#*' \) \
		-print0 | xargs -0r rm -rf --
	for f in $(SUBDIRS_DISTCLEAN); do make -C $$f distclean; done

=== dyndns/Makefile ===
--- 
+++ 
@@ -5,7 +5,7 @@
 #
 # This is free software; you can redistribute it and/or modify it
 # under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
+# the Free Software Foundation; either version 3 of the License, or
 # (at your option) any later version.
 #
 # This program is distributed in the hope that it will be useful, but
@@ -14,10 +14,7 @@
 # General Public License for more details.
 #
 # You should have received a copy of the GNU General Public License
-# along with userv-utils; if not, write to the Free Software
-# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
-#
-# $Id: Makefile,v 1.1 2003/07/06 20:32:27 ian Exp $
+# along with userv-utils; if not, see http://www.gnu.org/licenses/.
 
 include ../settings.make
 
@@ -30,7 +27,7 @@
 		mkdir -p $(services)
 		cp dyndns $(services)/dyndns.distrib
 		cp dyndns-domains $(etcuserv)/dyndns-domains.example
-		echo usdyndns >$(etcuserv)/dyndns-service-users.example
+		echo _userv-dyndns >$(etcuserv)/dyndns-service-users.example
 
 install-docs:
 		mkdir -p $(docdir)/userv-dyndns

=== groupmanage/Makefile ===
--- 
+++ 
@@ -1,12 +1,15 @@
 # Makefile
 # installation runes for groupmanage
 
-# Copyright (C) 2003 Ian Jackson
-# This file is part of groupmanage, part of userv-utils
+# Copyright 1996-2013 Ian Jackson <ijackson@chiark.greenend.org.uk>
+# Copyright 1998 David Damerell <damerell@chiark.greenend.org.uk>
+# Copyright 1999,2003
+#    Chancellor Masters and Scholars of the University of Cambridge
+# Copyright 2010 Tony Finch <fanf@dotat.at>
 #
 # This is free software; you can redistribute it and/or modify it
 # under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
+# the Free Software Foundation; either version 3 of the License, or
 # (at your option) any later version.
 #
 # This program is distributed in the hope that it will be useful, but
@@ -15,10 +18,7 @@
 # General Public License for more details.
 #
 # You should have received a copy of the GNU General Public License
-# along with userv-utils; if not, write to the Free Software
-# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
-#
-# $Id: Makefile,v 1.2 2003/07/06 21:25:01 ian Exp $
+# along with userv-utils; if not, see http://www.gnu.org/licenses/.
 
 include ../settings.make

=== ipif/Makefile ===
# Makefile for ipif/udptunnel stuff

# This file is part of ipif, part of userv-util
#
# Copyright 1996-2013 Ian Jackson <ijackson@chiark.greenend.org.uk>
# Copyright 1998 David Damerell <damerell@chiark.greenend.org.uk>
# Copyright 1999,2003
#    Chancellor Masters and Scholars of the University of Cambridge
# Copyright 2010 Tony Finch <fanf@dotat.at>
#
# This is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with userv-utils; if not, see http://www.gnu.org/licenses/.

include ../settings.make

varlibvpn=	$(varlibuserv)/vpn
etcuserv=	$(etcdir)/userv
etcvpn=		$(etcuserv)/vpn

PROGRAM_TARGETS+=
PROGRAM_TARGETS$(depr)+= udptunnel-forwarder udptunnel-reconf

TARGETS+=		service
TARGETS$(depr)+=	blowfishtest
TARGETS+=		$(PROGRAM_TARGETS)

PROGRAMS$(depr)+=	udptunnel
PROGRAMS+=		$(PROGRAM_TARGETS)

DIRS+=			$(libuserv) $(etcuserv) $(services)
DIRS+=			$(docdir)/userv-ipif
DIRS+=			$(etcuserv)/ipif-access
DIRS$(depr)+=		$(bindir) $(varlibvpn) $(shareuserv)

SHAREFILES$(depr)+=	udptunnel-vpn-config.m4 udptunnel-vpn-defaults

MECHFILES=	null pkcs5 timestamp sequence blowfish
MECHOBJS=	$(foreach m, $(MECHFILES), mech-$m.o)

OBJS_FORWARD=	forwarder.o $(MECHOBJS) blowfish.o automech.c utils.c
OBJS_BFTEST=	blowfishtest.o blowfish.o hex.o

all:		$(TARGETS)

install:	all
		mkdir -p $(DIRS)
		cp -b service $(libuserv)/ipif
		cp -b service-wrap $(libuserv)/ipif-access
		set -e; for f in $(PROGRAMS); do cp -b $$f $(bindir)/.; done
		cp ipif $(services)/ipif:new
		set -e; cd $(services); test -f ipif || mv ipif:new ipif
		set -e; for f in $(SHAREFILES); do cp $$f $(shareuserv)/.; done

install-docs:
		sed -n '1,/^$$/p' service.c >$(docdir)/userv-ipif/service.c.txt

install-examples:
		set -e; if [ "x$depr" = x ]; then \
			mkdir -p $(etcvpn); \
			cp *.example $(etcvpn)/.; \
		fi

udptunnel-reconf:	udptunnel-reconf.pl Makefile
		perl -p 						  \
	-e '	print "							' \
	-e '\$$shareuserv= \"$(shareuserv)\";\n				' \
	-e '\$$etcvpn= \"$(etcvpn)\";\n					' \
	-e '\$$varlibvpn= \"$(varlibvpn)\";\n" if m#^\# \@\@\@\-#;	' \
	-e '	$$_="" if m/^\# \@\@\@\-/ .. m/^\# \-\@\@\@/;		' \
			<$< >$@.new
		chmod +x $@.new
		mv -f $@.new $@


udptunnel-forwarder:	$(OBJS_FORWARD)
		$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $(OBJS_FORWARD)

blowfishtest:		$(OBJS_BFTEST)
		$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $(OBJS_BFTEST)

automech.h:		automechgen.sh Makefile
		./$< $(MECHFILES)

automech.c:		automech.h

clean:
		rm -f *.o core automech.[ch] *~ ./#*#

realclean distclean:	clean
		rm -f $(TARGETS)

forwarder.o $(MECHOBJS) automech.o utils.o:	forwarder.h automech.h
blowfish.o mech-blowfish.o blowfishtest.o:	blowfish.h
blowfishtest.o hex.o:				hex.h

=== misc/Makefile ===
# Makefile
#
# Copyright 1996-2013 Ian Jackson <ijackson@chiark.greenend.org.uk>
# Copyright 1998 David Damerell <damerell@chiark.greenend.org.uk>
# Copyright 1999,2003
#    Chancellor Masters and Scholars of the University of Cambridge
# Copyright 2010 Tony Finch <fanf@dotat.at>
#
# This is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with userv-utils; if not, see http://www.gnu.org/licenses/.

include ../settings.make

install:
		mkdir -p $(bindir)
		cp mailq-wrapper $(bindir)/mailq
		mkdir -p $(sbindir)
		cp checkpasswd-service $(sbindir)/checkpasswd-service

install-examples:
		mkdir -p $(services)
		cp mailq ndc-reload checkpasswd-self checkpasswd-other \
			$(services)/.

install-docs:

=== debian/changelog ===
userv-utils (0.6.1-3) unstable; urgency=medium

  * Pass down Debian's CFLAGS and LDFLAGS (Closes: #1119602).
    Thanks to Emanuele Rocca for the report and fix.

 -- Sean Whitton <spwhitton@spwhitton.name>  Thu, 30 Oct 2025 18:34:00 +0000

=== debian/control ===
Source: userv-utils
Section: admin
Priority: optional
Maintainer: Sean Whitton <spwhitton@spwhitton.name>
Uploaders: Ian Jackson <ijackson@chiark.greenend.org.uk>
Build-Depends: debhelper-compat (= 12), rename
Standards-Version: 4.5.1
Rules-Requires-Root: binary-targets
Homepage: https://www.chiark.greenend.org.uk/ucgi/~ian/git?p=userv-utils.git;a=summary
Vcs-Git: https://git.spwhitton.name/userv-utils/
Vcs-Browser: https://git.spwhitton.name/userv-utils/

Package: userv-utils
Architecture: any
Depends: userv, ${shlibs:Depends}, ${misc:Depends}
Recommends: ${perl:Depends}
Description: privsep utilities collection
 Several small userv services, which allow certain system configuration
 actions to be delegated.  In each case the service is disabled unless
 enabled by symlink /etc/userv/services.d/* -> ../services-available/*.
 .
 ipif - allow non-root users to create network interfaces
 ucgi - run CGI programs in providing user's account
 mailq - allow users to view the mail queue
 ndc-reload  - allow certain users to reload the nameserver
 checkpasswd-* - allow users to run a UNIX password check
 groupmanage - allow users to create and manage a few groups each

Package: userv-dyndns
Architecture: all
Depends: userv, chiark-utils-bin, adduser, ${perl:Depends}, ${misc:Depends}
Recommends: bind
Description: dynamic DNS for shell account users
 userv-dyndns is a userv service which allows non-root users to
 modify individual DNS records in specified zones in a controlled way.
 .
 Typically, this can be used to provide a `dyndns.org'-like service
 which is modifiable by shell account users.
 .
 The default configuration creates the infrastructure (including a
 service user) but does not allow any users to modify the DNS.

Package: userv-git-daemon
Architecture: all
Depends: userv, git-core, adduser, ${perl:Depends}, ${misc:Depends}
Description: per-user git daemon service
 userv-git-daemon allows users to publish git repositories which will
 be published via the git protocol on 9418.  This is a bit like
 git-daemon except that the actual reading of each user's repositories
 is done as that user.
 .
 The default configuration does nothing: you must (a) manually copy
 the line from /usr/share/doc/examples/userv-git-daemon.inetd into
 /etc/inetd.conf and (b) specifically list hostnames and target
 directories in /etc/userv/git-urlmap.

=== debian/rules ===
--- 
+++ 
@@ -39,6 +39,7 @@
 override_dh_auto_build:
 	$(checkdir)
 	set -e; for s in $(subdirs_build); do \
+		SUBDIR_CFLAGS="$(CFLAGS)" SUBDIR_LDFLAGS="$(LDFLAGS)" \
 		$(MAKE) -C $$s all; \
 	done
 	touch build
